--
-- objectDestroyTrigger
--
-- @author:    	Xentro (www.fs-uk.com)(Marcus@Xentro.se)
-- @version:    v0.5
-- @date:       2013-06-23
-- 

objectDestroyTrigger = {};

local objectDestroyTrigger_mt = Class(objectDestroyTrigger, Object);
InitObjectClass(objectDestroyTrigger, "objectDestroyTrigger");

function objectDestroyTrigger.onCreate(id)
    local instance = objectDestroyTrigger:new(g_server ~= nil, g_client ~= nil);
	if instance:load(id) then
		g_currentMission:addOnCreateLoadedObject(instance);
		instance:register(true);
	else
		instance:delete();
	end;
end;
g_onCreateUtil.addOnCreateFunction("objectDestroyTrigger", objectDestroyTrigger.onCreate);

function objectDestroyTrigger:new(isServer, isClient, customMt)	
    local self = Object:new(isServer, isClient, objectDestroyTrigger_mt);
    self.className = "objectDestroyTrigger";
		
    return self;
end;

function objectDestroyTrigger:load(id)
	self.isEnabled = true;
	
	if self.isServer then
		self.triggerId = id;
		addTrigger(self.triggerId, "triggerCallback", self);
	end;
	
	return true;
end;

function objectDestroyTrigger:delete()
	if self.isServer then
		if self.triggerId ~= nil then
			removeTrigger(self.triggerId)
		end;
	end;
end;

function objectDestroyTrigger:readStream(streamId, connection)
end;

function objectDestroyTrigger:writeStream(streamId, connection)
end;

function objectDestroyTrigger:update(dt)
end;

function objectDestroyTrigger:triggerCallback(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
    assert(self.isServer);
	
	if self.isEnabled then
		if otherActorId ~= 0 then
			local object = g_currentMission:getNodeObject(otherShapeId);
			
			if object ~= nil then
				if onEnter then
					if object:isa(FillablePallet) or object:isa(Bale) then
						object:delete();
					end;
				end;
			end;
		end;
    end;
end;